﻿Imports System.IO
Imports Infragistics.Win.UltraWinGrid

Public Class Form1
    Private SortArray As Byte()

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim data As DataTable = Me.GetData()
        Me.ugr.SetDataBinding(data, data.TableName)
    End Sub

    Private Sub ButtonAdd_Click(sender As Object, e As EventArgs) Handles ButtonAdd.Click
        Dim layout = Me.ugr.DisplayLayout
        Dim band = layout.Bands(0)
        band.SortedColumns.Add(band.Columns(0), False)
        band.SortedColumns.Add(band.Columns(1), True)
        band.SortedColumns.Add(band.Columns(2), False)
    End Sub

    Private Sub ButtonSave_Click(sender As Object, e As EventArgs) Handles ButtonSave.Click
        Dim ms2 As New MemoryStream()

        ugr.DisplayLayout.Save(ms2, PropertyCategories.SortedColumns)
        Me.SortArray = ms2.ToArray()
        ms2.Close()

        ms2.Dispose()
    End Sub

    Private Sub ButtonClear_Click(sender As Object, e As EventArgs) Handles ButtonClear.Click
        Dim layout = Me.ugr.DisplayLayout
        Dim band = layout.Bands(0)
        band.SortedColumns.Clear()
    End Sub

    Private Sub ButtonLoad_Click(sender As Object, e As EventArgs) Handles ButtonLoad.Click
        Dim MS2 As New IO.MemoryStream(SortArray)
        MS2.Seek(0, IO.SeekOrigin.Begin)
        Me.ugr.DisplayLayout.Load(MS2, Infragistics.Win.UltraWinGrid.PropertyCategories.SortedColumns)
        MS2.Close()

        MS2.Dispose()
    End Sub

    Private Function GetData(Optional rows As Integer = 20, Optional cols As Integer = 5) As DataTable
        Dim dt As New DataTable()

        For col As Integer = 0 To cols - 1
            dt.Columns.Add(String.Format("Column #{0}", col + 1))
        Next

        For row As Integer = 0 To rows - 1
            Dim addRow As DataRow = dt.NewRow()
            For Each column As DataColumn In dt.Columns
                addRow(column) = String.Format("{0}.{1}", row + 1, column.Ordinal + 1)
            Next

            dt.Rows.Add(addRow)
        Next

        Return dt
    End Function
End Class
